/*!
 * Copyright 2014 Smart Parking. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*!
 * @module smartcloud/errors
 */

'use strict';

function FlowControlError( message ) {
    this.name = 'FlowControlError';
    this.message = message;
    this.isFlowControl = true;
}
FlowControlError.prototype = new Error;

function FunctionRetryError( message ) {
    this.message = message;
}
FunctionRetryError.prototype = new Error;

function OperationError( message ) {
    this.name = 'OperationError';
    this.message = message;
}
OperationError.prototype = new Error;

function NoRetryError( message ) {
    this.name = 'NoRetryError';
    this.message = message;
    this.skipRetry = true;
}
NoRetryError.prototype = new Error;

module.exports = {
  FlowControlError,
  FunctionRetryError,
  OperationError,
  NoRetryError,
};
